﻿Public Class Tempo
    'initialisation de l'objet 
    Dim mc68hc08 As New HC08(255, 65535, 4000000) 'accuA , registre HX , Fbus 

    Private Sub Chargement(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ComboBox1.Text = "1"
        TextBox5.Text = "Durée max = 65536 / ( Fbus / Prescaler )"
        mc68hc08.afficher()
    End Sub

    Private Sub Modif_FQuartz(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextFreqBus.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.Fbus = Double.Parse(TextFreqBus.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub Modif_AccuA(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextAccuAT2.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.AccuA = Byte.Parse(TextAccuAT2.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub Modif_Periode(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextTempo2.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.TempoPeriodeT2 = Double.Parse(TextTempo2.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub Modif_Cycle(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextCycleT2.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.TempoCyclesT2 = Double.Parse(TextCycleT2.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub Modif_registerHX(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextRegHX.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.RegisterHX = UShort.Parse(TextRegHX.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub T1ModifAccuA(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextaccuAT1.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.AccuA = Byte.Parse(TextaccuAT1.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub ModifTempo1sec(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextTempo1.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.TempoPeriodeT1 = Double.Parse(TextTempo1.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub Nop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextNopT1.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.Nop = Integer.Parse(TextNopT1.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub NopT2(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextNopT2.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.Nop = Integer.Parse(TextNopT2.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("Le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub Prescaler_change(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        mc68hc08.Prescaler = Integer.Parse(ComboBox1.Text)
        mc68hc08.afficher()
    End Sub

  
    Private Sub ModuloText(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles tbModulo.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.Modulo = UShort.Parse(tbModulo.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("le format n'est pas valide")
            End Try
        End If
    End Sub

    Private Sub DureeTimerText(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles tbDureeTimer.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Return) Then
            Try
                mc68hc08.DureeTimer = Double.Parse(tbDureeTimer.Text)
                mc68hc08.afficher()
            Catch ex As Exception
                MsgBox("dépassement de la durée max ou format non valide")
            End Try
        End If
    End Sub
End Class

Class HC08

    Private _AccuA As Byte
    Private _registerH As Byte
    Private _registerX As Byte
    Private _registerHX As UShort 'unsigned = de 0 à 65535
    ' Private _Fquartz As Double
    Private _Fbus As Double
    Private _Periode As Double
    Private _PeriodeMs As Double
    Private _PeriodeUs As Double
    Private _PeriodeNs As Double
    Private _TempoCyclesT1 As Double
    Private _TempoPeriodesT1 As Double
    Private _TempoCyclesT2 As Double
    Private _TempoPeriodesT2 As Double
    Private _AddNop As Integer = 0
    Private _CodeT1 As String
    Private _CodeT2 As String
    Private _Modulo As UShort
    Private _DureeTimer As Double
    Private _Prescaler As Integer
    Private _DureeMaxTimer As Double


    'creation de l'objet 
    Public Sub New(ByVal AccuA As Byte, ByVal RegHX As UShort, ByVal Fbus_Hz As Double)
        'on passe par les propriétés
        Me.AccuA = AccuA
        Me.RegisterHX = RegHX
        Me.Fbus = Fbus_Hz
        Me.Prescaler = 1
        Me.Modulo = 1
    End Sub



    Public Property AccuA() As Byte
        Get
            Return _AccuA
        End Get
        Set(ByVal value As Byte)
            _AccuA = value
            'tempo1
            If AccuA = 0 Then
                TempoCyclesT1 = 6 + 2 + (4 * 256)
            Else
                TempoCyclesT1 = 6 + 2 + (4 * _AccuA)
            End If
            'tempo2
            If AccuA = 0 AndAlso RegisterHX = 0 Then
                TempoCyclesT2 = (8 * 65536 * 256) + (7 * 255) + 15
            ElseIf AccuA = 0 Then
                TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString) * 256) + (7 * (255 - 1)) + 10
            ElseIf RegisterHX = 0 Then
                TempoCyclesT2 = 5 + (8 * 65536 * AccuA) + (7 * (AccuA - 1)) + 10
            ElseIf AccuA = 1 AndAlso RegisterHX = 1 Then
                TempoCyclesT2 = 23
            ElseIf AccuA = 1 Then
                TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString)) + 7 + 10
            ElseIf RegisterHX = 1 Then
                TempoCyclesT2 = 2 + (15 * AccuA) + 6
            Else
                TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString) * AccuA) + (7 * (AccuA - 1)) + 10
            End If
        End Set
    End Property

    Public Property RegisterHX() As UShort
        Get
            Return _registerHX
        End Get
        Set(ByVal value As UShort)
            _registerHX = value
            If AccuA = 0 AndAlso RegisterHX = 0 Then
                TempoCyclesT2 = (8 * 65536 * 256) + (7 * 255) + 15
            ElseIf AccuA = 0 Then
                TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString) * 256) + (7 * (255 - 1)) + 10
            ElseIf RegisterHX = 0 Then
                TempoCyclesT2 = 5 + (8 * 65536 * AccuA) + (7 * (AccuA - 1)) + 10
            ElseIf AccuA = 1 AndAlso RegisterHX = 1 Then
                TempoCyclesT2 = 23
            ElseIf AccuA = 1 Then
                TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString)) + 7 + 10
            ElseIf RegisterHX = 1 Then
                TempoCyclesT2 = 2 + (15 * AccuA) + 6
            Else
                TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString) * AccuA) + (7 * (AccuA - 1)) + 10
            End If
        End Set
    End Property


    'Public Property Fquartz() As Double
    '    Get
    '        Return _Fquartz
    '    End Get
    '    Set(ByVal value As Double)
    '        _Fquartz = value
    '        _Fbus = _Fquartz / 4
    '        _Periode = 1 / _Fbus
    '        _PeriodeMs = _Periode * 1000
    '        _PeriodeUs = _PeriodeMs * 1000
    '        _PeriodeNs = _PeriodeUs * 1000
    '    End Set
    'End Property
    Public Property Fbus() As Double
        Get
            Return _Fbus
        End Get
        Set(ByVal value As Double)
            _Fbus = value
            _Periode = 1 / Fbus
            _PeriodeMs = Periode * 1000
            _PeriodeUs = PeriodeMs * 1000
            _PeriodeNs = PeriodeUs * 1000
        End Set
    End Property
    Public ReadOnly Property Periode() As Double
        Get
            Return _Periode
        End Get
        'Set(ByVal value As Double)
        '    _Periode = value
        'End Set
    End Property

    Public ReadOnly Property PeriodeMs() As Double
        Get
            Return _PeriodeMs
        End Get
    End Property

    Public ReadOnly Property PeriodeUs() As Double
        Get
            Return _PeriodeUs
        End Get
    End Property
    Public ReadOnly Property PeriodeNs() As Double
        Get
            Return _PeriodeNs
        End Get
    End Property



    Public Property Modulo() As UShort
        Get
            Return _Modulo
        End Get
        Set(ByVal value As UShort)
            _Modulo = value
            'periode du timer 
            If Modulo <> 0 Then
                _DureeTimer = Modulo / (Fbus / Prescaler)
            Else
                _DureeTimer = 65536 / (Fbus / Prescaler)
            End If
        End Set
    End Property

    Public Property Prescaler() As Integer
        Get
            Return _Prescaler
        End Get
        Set(ByVal value As Integer)
            _Prescaler = value
            'visualisation de la durée max en fonction du prescaler 
            _DureeMaxTimer = 65536 / (Fbus / Prescaler)
        End Set
    End Property

    Public Property DureeTimer() As Double
        Get
            Return _DureeTimer
        End Get
        Set(ByVal value As Double)
            _DureeTimer = value
            Modulo = CUShort((Fbus / Prescaler) * DureeTimer)
        End Set
    End Property

    Public ReadOnly Property DureeMax() As Double
        Get
            Return _DureeMaxTimer
        End Get
        'Set(ByVal value As Double)
        '   _DureeMaxTimer = value 
        'End Set
    End Property

    Public Property CodeT1() As String
        Get
            Return _CodeT1
        End Get
        Set(ByVal value As String)
            _CodeT1 = value
        End Set
    End Property



    Public Property CodeT2() As String
        Get
            Return _CodeT2
        End Get
        Set(ByVal value As String)
            _CodeT2 = value
        End Set
    End Property


    Public Property TempoPeriodeT1() As Double
        Get
            Return _TempoPeriodesT1
        End Get
        Set(ByVal value As Double)
            _TempoPeriodesT1 = value
            TempoCyclesT1 = Math.Round(_TempoPeriodesT1 / _Periode)
            ' TempoCyclesT1 = 6 + 2 + (4 * _AccuA)
            If TempoCyclesT1 >= 8 AndAlso TempoCyclesT1 <= 1028 Then
                For x = 8 To 1028 Step 4
                    If TempoCyclesT1 = x Then
                        AccuA = Byte.Parse(((TempoCyclesT1 - 8) / 4).ToString)
                    End If
                Next
            End If
        End Set
    End Property

    Public Property TempoPeriodeT2() As Double
        Get
            Return _TempoPeriodesT2
        End Get
        Set(ByVal value As Double)
            _TempoPeriodesT2 = value
            TempoCyclesT2 = Math.Round(_TempoPeriodesT2 / _Periode)
        End Set
    End Property

    Public Property TempoCyclesT1() As Double
        Get
            Return _TempoCyclesT1
        End Get
        Set(ByVal value As Double)
            _TempoCyclesT1 = value
            _CodeT1 = String.Format("tempo1: LDA #${0:X2}  ;2 cycles{1}" & _
                                    "TP1     DBNZA TP1  ; 4cycles{1}" & _
                                    "        RTS ; 6 cycles", _AccuA, System.Environment.NewLine)
            _CodeT2 = String.Format("tempo2:  LDA #${0:X2}  ;2 cycles{2}" & _
                                    "TP21:    LDHX #${1:X4} ; 3 cycles{2}" & _
                                    "TP22:    AIX #-1  ;2 cycles{2}" & _
                                    "         CPHX #$0000 ; 3 cycles{2}" & _
                                    "         BNE TP22  ; 3 cycles{2}" & _
                                    "         DBNZA TP21  ; 4cycles{2}" & _
                                    "         RTS ; 6 cycles{2}", AccuA, RegisterHX, System.Environment.NewLine)
        End Set
    End Property


    Public Property TempoCyclesT2() As Double
        Get
            Return _TempoCyclesT2
        End Get
        Set(ByVal value As Double)
            _TempoCyclesT2 = value
            _CodeT1 = String.Format("tempo1: LDA #${0:X2}  ;2 cycles{1}" & _
                                    "TP1     DBNZA TP1  ; 4cycles{1}" & _
                                    "        RTS ; 6 cycles", _AccuA, System.Environment.NewLine)
            _CodeT2 = String.Format("tempo2:  LDA #${0:X2}  ;2 cycles{2}" & _
                                    "TP21:    LDHX #${1:X4} ; 3 cycles{2}" & _
                                    "TP22:    AIX #-1  ;2 cycles{2}" & _
                                    "         CPHX #$0000 ; 3 cycles{2}" & _
                                    "         BNE TP22  ; 3 cycles{2}" & _
                                    "         DBNZA TP21  ; 4cycles{2}" & _
                                    "         RTS ; 6 cycles{2}", AccuA, RegisterHX, System.Environment.NewLine)
        End Set
    End Property


    Public Property Nop() As Integer
        Get
            Return _AddNop
        End Get
        Set(ByVal value As Integer)
            _AddNop = value
            If Nop <> 0 Then
                TempoCyclesT1 += Nop
                TempoCyclesT2 += Nop
            Else
                'tempo1
                If AccuA = 0 Then
                    TempoCyclesT1 = 6 + 2 + (4 * 256)
                Else
                    TempoCyclesT1 = 6 + 2 + (4 * _AccuA)
                End If
                'tempo2
                If AccuA = 0 AndAlso RegisterHX = 0 Then
                    TempoCyclesT2 = (8 * 65536 * 256) + (7 * 255) + 15
                ElseIf AccuA = 0 Then
                    TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString) * 256) + (7 * (255 - 1)) + 10
                ElseIf RegisterHX = 0 Then
                    TempoCyclesT2 = 5 + (8 * 65536 * AccuA) + (7 * (AccuA - 1)) + 10
                ElseIf AccuA = 1 AndAlso RegisterHX = 1 Then
                    TempoCyclesT2 = 23
                ElseIf AccuA = 1 Then
                    TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString)) + 7 + 10
                ElseIf RegisterHX = 1 Then
                    TempoCyclesT2 = 2 + (15 * AccuA) + 6
                Else
                    TempoCyclesT2 = 5 + (8 * Val(RegisterHX.ToString) * AccuA) + (7 * (AccuA - 1)) + 10
                End If
            End If
        End Set
    End Property

    Public Sub afficher()
        My.Forms.Tempo.TextFreqBus.Text = Me.Fbus.ToString
        My.Forms.Tempo.TextTsec.Text = String.Format("{0,15:#.############}", Me.Periode) 'en seconde
        My.Forms.Tempo.TextTms.Text = Me.PeriodeMs.ToString
        My.Forms.Tempo.TextTus.Text = Me.PeriodeUs.ToString
        My.Forms.Tempo.TextTns.Text = Me.PeriodeNs.ToString
        My.Forms.Tempo.TextaccuAT1.Text = Me.AccuA.ToString("X") 'X pour hexadecimal
        My.Forms.Tempo.TextAccuAT2.Text = Me.AccuA.ToString("X") 'X pour hexadecimal
        My.Forms.Tempo.TextRegHX.Text = Me.RegisterHX.ToString("X") 'X pour hexadecimal
        My.Forms.Tempo.TextNopT1.Text = Me._AddNop.ToString
        My.Forms.Tempo.TextNopT2.Text = Me._AddNop.ToString
        My.Forms.Tempo.codeT1.Text = Me.CodeT1
        My.Forms.Tempo.CodeT2.Text = Me.CodeT2
        My.Forms.Tempo.TextcycleT1.Text = Me._TempoCyclesT1.ToString
        My.Forms.Tempo.TextCycleT2.Text = Me._TempoCyclesT2.ToString
        My.Forms.Tempo.TextTempo1.Text = String.Format("{0,15:#.############}", Me._TempoCyclesT1 * Me._Periode)
        My.Forms.Tempo.TextTempo2.Text = String.Format("{0,15:#.############}", Me._TempoCyclesT2 * Me._Periode)
        My.Forms.Tempo.TextTsec.SelectAll() ' pour affichage correct
        My.Forms.Tempo.tbModulo.Text = Me._Modulo.ToString("X")
        My.Forms.Tempo.tbDureeTimer.Text = String.Format("{0,15:#.############}", Me._DureeTimer) 'en seconde
        My.Forms.Tempo.DureeMaxTimer.Text = Me._DureeMaxTimer.ToString
    End Sub



End Class